
clf reset

date = '20130116';
%FILTER = 'OH';
aa = 148;
bb = aa + 1;

%data_dir = strcat('C:\Users\Karoline Nr\Documents\prosjekt\imager\',date,'\',FILTER,'\');
data_dir = strcat('C:\Users\Karoline Nr\Documents\prosjekt\imager\',date,'\');
qqqfiles = dir(strcat(data_dir,'*.fit'));

A = fitsread(strcat(data_dir,qqqfiles(aa).name));
B = fitsread(strcat(data_dir,qqqfiles(bb).name));

A = medfilt2(medfilt2(medfilt2(medfilt2(medfilt2(A)))));
A = wiener2(wiener2(wiener2(wiener2(wiener2(wiener2(A))))));

B = medfilt2(medfilt2(medfilt2(medfilt2(medfilt2(medfilt2(B))))));
B = wiener2(wiener2(wiener2(wiener2(wiener2(wiener2(B))))));

A = int16(A);
B = int16(B);

x = imsubtract(A,B);

x = medfilt2(medfilt2(medfilt2(medfilt2(medfilt2(x)))));
x = wiener2(wiener2(wiener2(wiener2(wiener2(x)))));
x = x - min(min(x));



sizeProjection = 100000; 


x = x(1:1252,206:1457); 
[iSize jSize] = size(x);

y = zeros(iSize,jSize); 

if mod(length(x),2) ~= 0
   disp('Original image pixel count is not equal to an even number')
end

if mod(length(y),2) ~= 0
   disp('Mapped image pixel count is not equal to an even number')
end



 a = 6378.135*10^3;
 b = 6356.75*10^3;
 geolat = 63.406809*pi/180;
 R = sqrt( ((a^2*cos(geolat))^2 + (b^2*sin(geolat))^2) / ((a*cos(geolat))^2 +(b*sin(geolat))^2 ));

 
 
 az = 0.0;
 el = 0.0;
 r = 0.0;
 psi = 0.0;
 a = 0.0;
 c = 0.0;
 alph = 0.0;
 rFish = 0.0;

 h = 87*10^3; %Height of satellite
 centerI = 665.4474; %Location of zenith in original image
 centerJ = 835.6473-206; % 206 To compensate that the image has been cropped.
 ppd = 14.0595;%Pixels per degree
 scale = sizeProjection/(length(x)); %
 
 
 decimalK = 0.0;
 decimalO = 0.0;
 

 
 %Making geographically mapped image with same resolution as fish eye image
 for i=1:iSize,
    for j=1:jSize,
        r=sqrt((i-iSize/2)^2+(j-jSize/2)^2);
        r=r*scale; %To give images that covers an area sizeProjection X sizeProjection


        az=atan((iSize/2-i)/(j-jSize/2));


        if (j-jSize/2) < 0
            az=az+pi;
        elseif(j-jSize/2) == 0 && (iSize/2-i) < 0
            az=3/2*pi;
        elseif (j-jSize/2) > 0 && (iSize/2-i) < 0
            az=az+2*pi;
        end

 %Now radius and azimuth in geographical coordinates ...has been
 %obtained. Finding corresponding radius in fisheye ...image via
 %elevation.

        psi=r/(R+h);
        a=2*(R+h)*sin(psi/2);
        alph=(pi-psi)/2;
        c=sqrt(h^2+a^2-2*h*a*cos(alph));
        el=acos(a*sin(alph)/c);

        rFish=ppd*(90-el*180/pi);

 %Finding float indices in fish eye image ...corresponding to indices
 %of pixel in geographical image.
        o=-rFish*sin(az)+centerI;
        k=rFish*cos(az)+centerJ;

 %Handling NAN issues
        if i == iSize/2 && j == jSize/2
            o=centerI;
            k=centerJ;
        end

 
         decimalK=k-floor(k);
         decimalO=o-floor(o);
 
 
         if (decimalK > 0.0) && (decimalK < 0.5 )
             avgk=x(round(o),floor(k))*(1-decimalK)+x(round(o),ceil(k))*decimalK;
         elseif decimalK >= 0.5
              avgk=x(round(o),ceil(k))*(decimalK)+x(round(o),floor(k))*(1-decimalK);
         elseif decimalK==0;
              avgk=x(round(o),round(k));
         end
 
         if (decimalO > 0.0) && (decimalO < 0.5 )
             if (decimalK > 0.0) && (decimalK < 0.5 )
                 avgo=x(floor(o)+1,round(k))*(1-decimalK)+x(floor(o)+1,ceil(k))*decimalK;
             elseif decimalK >= 0.5
                 avgo=x(floor(o)+1,ceil(k))*(decimalK)+x(floor(o)+1,floor(k))*(1-decimalK);
             elseif decimalK==0;
                 avgo=x(floor(o)+1,round(k));
             end
         elseif decimalO >= 0.5
             if (decimalK > 0.0) && (decimalK < 0.5 )
                 avgo=x(floor(o)-1,round(k))*(1-decimalK)+x(floor(o)-1,ceil(k))*decimalK; 
           
             elseif decimalK >= 0.5
                 avgo=x(floor(o)-1,ceil(k))*(decimalK)+x(floor(o)-1,floor(k))*(1-decimalK);
             elseif decimalK==0;
                  avgo=x(floor(o)-1,round(k));
             end
         else
             avgo=x(round(o),round(k));
         end
 
         if (decimalO > 0.0) && (decimalO < 0.5 )
             avg=avgk*(1-decimalO) + avgo*decimalO;
         elseif decimalO >= 0.5
             avg=avgk*(decimalO)+avgo*(1-decimalO);
         else
             avg=avgk;
         end
 
         %y(i,j)=avg; % Fills geographically mapped image with interpolated values from fish eye image.

        
        
        y(i,j) = x(round(o),round(k)); %To test without interpolation.
        % Introduces rounding errors.

    end
 end

imagesc(y, [550, 650]);colormap(gray); axis image; axis off;
%hold;text(3,(35),txt,'FontName', 'TimesNewRoman','FontSize',10,'FontWeight','bold', 'color', 'y'),hold; 

figure()
[a1, a2, a3, a4, wn, amp, ph Xi Yi ORIG] = findsineTF3(y);

lambdaPix = (2*pi)/wn;
lambda = lambdaPix*scale/1000

amplitude = amp
phase = ph


S1 = Xi;
S2 = Yi;

Orig = ORIG;
