
function [cx cy c data WN RealAmp PH xi yi orig] = findsineTF3(x)
p=x;

% Data=zeros(6,4);
%-------------Defining the sine function for fitting-----------------
modelFun =  @(p,x) p(1)*sin(p(2)*x) + p(3)*cos(p(2)*x) + p(4); 
%startingVals = [    10      2*pi/50    4.4752   0.0]; startingvals is a vector containing initial values for the coefficients
%startingVals = [    200      2*pi/500    4.4752   0.0];
startingVals = [    300      2*pi/300    300   0.0]; % seems to work fine for distinct waves!
%startingVals = [amplitude wavenumber phase constant]



%-------------Making difference image-----------------------------

imsuborig=x;


% imsuborig=medfilt2(medfilt2(medfilt2(medfilt2(imsuborig))));


[r,c] = size(imsuborig); %# Get the image size

m1=[588 464];
m2=[1155 127];


%--------------Collecting data-----------------------------------
    imshow(imsuborig);
    %imcontrast();
    [cx,cy,c] = improfile(x, m1, m2);
    xi=[cx(1) cx(length(cx))]                                          %First and last "x" index in sampled line
    yi=[cy(1) cy(length(cy))]                                          %First and last "y" index in sampled line
    lengthorig = length(transpose(improfile(imsuborig,xi,yi)));       %Length of sampled line
    
    v1=[1,0];
    v2=[xi(2)-xi(1),yi(2)-yi(1)];
    a=acosd(dot(v1,v2)/(norm(v1)*norm(v2)))
    
    if yi(2) > yi(1)
        a=-a;
    end
                                        
       imshow(imsuborig);
    hold on;
    data= zeros(7,39);% data to store the wavelength
for o=-19:19 ,    %Sampling different angles
    o=o/4;
    x=lengthorig*cosd(a+o);
    y=lengthorig*sind(a+o);
    

    xi=[cx(1) cx(1)+x];
    yi=[cy(1) cy(1)-y];
    
    i=sind(90-a+o);
    j=cosd(90-a+o);
    
 
 
    
    
    %Sampling paralell lines
    orig=zeros(1,lengthorig);
    for w=0:0, %From zero to compensate to the original included on rec. 
        
        temporig=transpose(improfile(imsuborig,    xi(:)-j*w   ,     yi(:)-i*w,   lengthorig));
        orig(:) = orig(:) + temporig(:); 
        line([xi(1)-j*w,xi(2)-j*w],[yi(1)-i*w,yi(2)-i*w])   %To plot samples 
    end

    
    hold off
    
%     
    xValues=1:lengthorig;
%     
% 
% 
    [coefEstsy,Ry,Jy,CovBy,MSEy]= nlinfit(xValues, orig, modelFun, startingVals);
    
    data(:,o*4+20)=[coefEstsy(1) coefEstsy(2) coefEstsy(3) xi(1) xi(2) yi(1) yi(2)] ;

    
end



AMP1 = coefEstsy(1);
WN = coefEstsy(2);
AMP2 = coefEstsy(3);

RealAmp = sqrt(AMP1^2 + AMP2^2);
PH = atan2(AMP1,AMP2);

figure()
y = linspace(1,39,39);
whos y
whos data

scatter(y,data(2,:))

figure()
    plot(xValues,orig,'r');
    line(xValues, modelFun(coefEstsy, xValues))
    xlabel('Pixel'); ylabel('Intensity');
    
    
    


end




